
// This script serves as a quick setup and bootstrapping routine for modu. It
// isn't extensively tested but is based on the premise of a LABjs bootstrapper
// using more or less the very same mechanism. It also provides its minimal
// loader routine to modu for further use (though in the future modu might also
// defer to LABjs if it is available).

#include "general.h"

(function(moduBaseDir, moduSetupKey, moduUserKey) {
	var
		mainScriptLocation = moduBaseDir + "/modu.js",
		modulesScriptLocation = moduBaseDir + "/modules.js";

#include "build/general.jsl"	
#include "build/on-head-ready.jsl"
#include "build/script-loader.jsl"
#include "build/firefox-document-ready-state-shim.jsl"
	
	addScript(mainScriptLocation, function() {
		win[moduSetupKey]["load"](modulesScriptLocation, function() {
			// And de-pollute the namespace
			delete win[moduSetupKey];
		});
	});
})(
	// modu home path
	HOME_PATH,
	// setup key (modu.js places setup function here)
	SETUP_KEY,
	// user key (library interface is placed here)
	USER_KEY
);
