
#include "general.h"


// This implementation requires onHeadReady

// Creates a new script element, adds it to the document head, and calls
// the callback when the script has loaded.
function addScript(loc, onload) {
	onHeadReady(function(head) {
		var ele = document[$createElement]($script),
			done = false;
		ele[$onload] = ele[$onrs] = function() {
			// Don't trigger if already triggered
			if(!done) {
				// If not already triggered, don't trigger unless
				// complete/loaded
				var rs = ele[$rs];
				if(!(rs && rs !== $complete && rs !== $loaded)) {
					// Trigger here
					done = true;
					// Prevent logical memory leak
					delete ele[$onload];
					delete ele[$onrs];
					// Call callback
					onload && onload();
				}
			}
			return done;
		};
	});
}

